diff --git a/lib/http1.c b/lib/http1.c
index beafec3651..21c5517133 100644
--- a/lib/http1.c
+++ b/lib/http1.c
@@ -259,6 +259,11 @@ static void reqread_on_timeout(h2o_timeout_entry_t *entry)
 
 static inline void reqread_start(h2o_http1_conn_t *conn)
 {
+    if (conn->sock->input != NULL && conn->sock->input->size != 0) {
+        if (handle_incoming_request(conn) == 0) {
+            return;
+        }
+    }
     set_timeout(conn, &conn->super.ctx->req_timeout, reqread_on_timeout);
     h2o_socket_read_start(conn->sock, reqread_on_read);
 }
@@ -290,11 +295,6 @@ static void on_send_complete(h2o_socket_t *sock, int status)
     h2o_consume_input_buffer(&conn->sock->input, conn->_reqsize);
     conn->_prevreqlen = 0;
     conn->_reqsize = 0;
-    if (conn->sock->input->size != 0) {
-        if (handle_incoming_request(conn) == 0) {
-            return;
-        }
-    }
     reqread_start(conn);
 }
 
diff --git a/lib/socket.c b/lib/socket.c
index 0bce950f0e..068a93cee1 100644
--- a/lib/socket.c
+++ b/lib/socket.c
@@ -164,6 +164,7 @@ int decode_ssl_input(h2o_socket_t *sock)
         }
     }
 
+    assert(sock->ssl->input.encrypted->size == 0);
     return 0;
 }
 
@@ -268,6 +269,7 @@ static void on_handshake_complete(h2o_socket_t *sock, int status)
     h2o_socket_cb handshake_cb = sock->ssl->handshake.cb;
     sock->_cb.write = NULL;
     sock->ssl->handshake.cb = NULL;
+    decode_ssl_input(sock);
     handshake_cb(sock, status);
 }
 
@@ -293,6 +295,10 @@ static void proceed_handshake(h2o_socket_t *sock, int status)
         h2o_socket_read_stop(sock);
         flush_pending_ssl(sock, ret == 1 ? on_handshake_complete : proceed_handshake);
     } else {
+        if (ret == 1) {
+            goto Complete;
+        }
+        assert(sock->ssl->input.encrypted == NULL || sock->ssl->input.encrypted->size == 0);
         h2o_socket_read_start(sock, proceed_handshake);
     }
     return;
